Index: issm/trunk/src/c/objects/FemModel.cpp
===================================================================
--- issm/trunk/src/c/objects/FemModel.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/FemModel.cpp	(revision 4055)
@@ -35,17 +35,17 @@
 	/*Dynamically allocate whatever is a list of length nummodels: */
 	analysis_type_list=(int*)xmalloc(nummodels*sizeof(int));
-	Rmg=(Mat*)xmalloc(nummodels*sizeof(Mat));
-	Gmn=(Mat*)xmalloc(nummodels*sizeof(Mat));
-	nodesets=(NodeSets**)xmalloc(nummodels*sizeof(NodeSets*));
-	yg=(Vec*)xmalloc(nummodels*sizeof(Vec));
-	ys=(Vec*)xmalloc(nummodels*sizeof(Vec));
+	m_Rmg=(Mat*)xmalloc(nummodels*sizeof(Mat));
+	m_Gmn=(Mat*)xmalloc(nummodels*sizeof(Mat));
+	m_nodesets=(NodeSets**)xmalloc(nummodels*sizeof(NodeSets*));
+	m_yg=(Vec*)xmalloc(nummodels*sizeof(Vec));
+	m_ys=(Vec*)xmalloc(nummodels*sizeof(Vec));
 
 	/*Initialize: */
 	for(i=0;i<nummodels;i++)analysis_type_list[i]=analyses[i];
-	for(i=0;i<nummodels;i++)Rmg[i]=NULL;
-	for(i=0;i<nummodels;i++)Gmn[i]=NULL;
-	for(i=0;i<nummodels;i++)nodesets[i]=NULL;
-	for(i=0;i<nummodels;i++)yg[i]=NULL;
-	for(i=0;i<nummodels;i++)ys[i]=NULL;
+	for(i=0;i<nummodels;i++)m_Rmg[i]=NULL;
+	for(i=0;i<nummodels;i++)m_Gmn[i]=NULL;
+	for(i=0;i<nummodels;i++)m_nodesets[i]=NULL;
+	for(i=0;i<nummodels;i++)m_yg[i]=NULL;
+	for(i=0;i<nummodels;i++)m_ys[i]=NULL;
 
 	_printf_("   fill model with matlab workspace data\n");
@@ -64,17 +64,17 @@
 
 		_printf_("   create single point constraints: \n");
-		SpcNodesx( &yg[i], nodes,constraints,analysis_type); 
+		SpcNodesx( &m_yg[i], nodes,constraints,analysis_type); 
 
 		_printf_("   create rigid body constraints:\n");
-		MpcNodesx( &Rmg[i], nodes,constraints,analysis_type); 
+		MpcNodesx( &m_Rmg[i], nodes,constraints,analysis_type); 
 
 		_printf_("   create node sets:\n");
-		BuildNodeSetsx(&nodesets[i], nodes,analysis_type);
+		BuildNodeSetsx(&m_nodesets[i], nodes,analysis_type);
 
 		_printf_("   reducing single point constraints vector:\n");
-		Reducevectorgtosx(&ys[i], yg[i],nodesets[i]);
+		Reducevectorgtosx(&m_ys[i], m_yg[i],m_nodesets[i]);
 
 		_printf_("   normalizing rigid body constraints matrix:\n");
-		NormalizeConstraintsx(&Gmn[i], Rmg[i],nodesets[i]);
+		NormalizeConstraintsx(&m_Gmn[i], m_Rmg[i],m_nodesets[i]);
 
 		_printf_("   configuring element and loads:\n");
@@ -106,22 +106,22 @@
 
 	for(i=0;i<nummodels;i++){
-		Mat temp_Rmg=Rmg[i];
+		Mat temp_Rmg=m_Rmg[i];
 		MatFree(&temp_Rmg);
-		Mat temp_Gmn=Gmn[i];
+		Mat temp_Gmn=m_Gmn[i];
 		MatFree(&temp_Gmn);
-		NodeSets* temp_nodesets=nodesets[i];
-		delete nodesets;
-		Vec temp_yg=yg[i];
+		NodeSets* temp_nodesets=m_nodesets[i];
+		delete temp_nodesets;
+		Vec temp_yg=m_yg[i];
 		VecFree(&temp_yg);
-		Vec temp_ys=ys[i];
+		Vec temp_ys=m_ys[i];
 		VecFree(&temp_ys);
 	}
 
 	/*Delete dynamically allocated arrays: */
-	delete Rmg;
-	delete Gmn;
-	delete nodesets;
-	delete yg;
-	delete ys;
+	delete m_Rmg;
+	delete m_Gmn;
+	delete m_nodesets;
+	delete m_yg;
+	delete m_ys;
 
 }
@@ -151,4 +151,5 @@
 /*FUNCTION FemModel::SetCurrentAnalysis {{{1*/
 void FemModel::SetCurrentAnalysis(int analysis_type){
+
 	int found=-1;
 	for(int i=0;i<nummodels;i++){
@@ -160,4 +161,25 @@
 	if(found!=-1) analysis_counter=found;
 	else ISSMERROR("Could not find analysis_type %s in list of FemModel analyses",EnumAsString(analysis_type));
+
+	/*activate matrices/vectors: */
+	Rmg=m_Rmg[analysis_counter];
+	Gmn=m_Gmn[analysis_counter];
+	nodesets=m_nodesets[analysis_counter];
+	yg=m_yg[analysis_counter];
+	ys=m_ys[analysis_counter];
+
+}
+/*}}}1*/
+/*FUNCTION FemModel::SetCurrentAnalysisAlias {{{1*/
+void FemModel::SetCurrentAnalysisAlias(int base_analysis_type,int real_analysis_type){
+	int found=-1;
+	for(int i=0;i<nummodels;i++){
+		if (analysis_type_list[i]==base_analysis_type){
+			found=i;
+			break;
+		}
+	}
+	if(found!=-1) analysis_counter=found;
+	else ISSMERROR("Could not find alias for analysis_type %s in list of FemModel analyses",EnumAsString(base_analysis_type));
 }
 /*}}}1*/
Index: issm/trunk/src/c/objects/FemModel.h
===================================================================
--- issm/trunk/src/c/objects/FemModel.h	(revision 4054)
+++ issm/trunk/src/c/objects/FemModel.h	(revision 4055)
@@ -40,10 +40,17 @@
 		DofVec*             tpartition;
 		
-		//multiple  sets of matrices/vectors for each analysis_type
-		Mat*                 Rmg; //rigid body motions matrices
-		Mat*                 Gmn;
-		NodeSets**           nodesets; //boundary conditions dof sets
-		Vec*                 yg; //boundary conditions in global g-set
-		Vec*                 ys; //boundary conditions, in reduced s-set
+		//multiple  sets of matrices/vectors for each analysis_type. m stands for multiple
+		Mat*                 m_Rmg; //rigid body motions matrices
+		Mat*                 m_Gmn;
+		NodeSets**           m_nodesets; //boundary conditions dof sets
+		Vec*                 m_yg; //boundary conditions in global g-set
+		Vec*                 m_ys; //boundary conditions, in reduced s-set
+
+		//pointers to point to sets of matrices/vectors, for a certain analysis type. activated in SetCurrentAnalysis
+		Mat                  Rmg;
+		Mat                  Gmn;
+		NodeSets*            nodesets;
+		Vec                  yg;
+		Vec                  ys;
 
 		/*constructors, destructors: */
@@ -56,4 +63,5 @@
 		/*Fem: */
 		void  SetCurrentAnalysis(int analysis_type);
+		void  SetCurrentAnalysisAlias(int base_analysis_type,int real_analysis_type);
 		int   GetCurrentAnalysis(void);
 
Index: issm/trunk/src/c/objects/Inputs/BeamVertexInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/BeamVertexInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/BeamVertexInput.cpp	(revision 4055)
@@ -294,2 +294,10 @@
 }
 /*}}}*/
+/*FUNCTION BeamVertexInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void BeamVertexInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	*pvalues=this->values;
+	*pnum_values=2;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/BeamVertexInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/BeamVertexInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/BeamVertexInput.h	(revision 4055)
@@ -78,4 +78,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/BoolInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/BoolInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/BoolInput.cpp	(revision 4055)
@@ -256,2 +256,9 @@
 }
 /*}}}*/
+/*FUNCTION BoolInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void BoolInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	ISSMERROR(" not supported yet!");
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/BoolInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/BoolInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/BoolInput.h	(revision 4055)
@@ -78,4 +78,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/DoubleInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/DoubleInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/DoubleInput.cpp	(revision 4055)
@@ -267,2 +267,9 @@
 }
 /*}}}*/
+/*FUNCTION DoubleInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void DoubleInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	ISSMERROR(" not supported yet!");
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/DoubleInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/DoubleInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/DoubleInput.h	(revision 4055)
@@ -79,4 +79,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/Input.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/Input.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/Input.h	(revision 4055)
@@ -55,4 +55,5 @@
 		virtual void Constrain(double cm_min, double cm_max)=0;
 		virtual void GetVectorFromInputs(Vec vector,int* doflist)=0;
+		virtual void GetValuesPtr(double* pvalues,int* pnum_values)=0;
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/IntInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/IntInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/IntInput.cpp	(revision 4055)
@@ -257,2 +257,9 @@
 }
 /*}}}*/
+/*FUNCTION IntInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void IntInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	ISSMERROR(" not supported yet!");
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/IntInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/IntInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/IntInput.h	(revision 4055)
@@ -78,4 +78,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/PentaVertexInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/PentaVertexInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/PentaVertexInput.cpp	(revision 4055)
@@ -943,2 +943,10 @@
 }
 /*}}}*/
+/*FUNCTION PentaVertexInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void PentaVertexInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	*pvalues=this->values;
+	*pnum_values=6;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/PentaVertexInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/PentaVertexInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/PentaVertexInput.h	(revision 4055)
@@ -87,4 +87,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/SingVertexInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/SingVertexInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/SingVertexInput.cpp	(revision 4055)
@@ -258,3 +258,11 @@
 
 }
-/*}}}*/
+/2*}}}*/
+/*FUNCTION SingVertexInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void SingVertexInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	*pvalues=&this->value;
+	*pnum_values=1;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/SingVertexInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/SingVertexInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/SingVertexInput.h	(revision 4055)
@@ -77,4 +77,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Inputs/TriaVertexInput.cpp
===================================================================
--- issm/trunk/src/c/objects/Inputs/TriaVertexInput.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/TriaVertexInput.cpp	(revision 4055)
@@ -517,2 +517,10 @@
 }
 /*}}}*/
+/*FUNCTION TriaVertexInput::GetValuesPtr(double* pvalues,int* pnum_values);{{{1*/
+void TriaVertexInput::GetValuesPtr(double* pvalues,int* pnum_values){
+
+	*pvalues=this->values;
+	*pnum_values=3;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Inputs/TriaVertexInput.h
===================================================================
--- issm/trunk/src/c/objects/Inputs/TriaVertexInput.h	(revision 4054)
+++ issm/trunk/src/c/objects/Inputs/TriaVertexInput.h	(revision 4055)
@@ -84,4 +84,5 @@
 		void Constrain(double cm_min, double cm_max);
 		void GetVectorFromInputs(Vec vector,int* doflist);
+		void GetValuesPtr(double* pvalues,int* pnum_values);
 		/*}}}*/
 
Index: issm/trunk/src/c/objects/Node.cpp
===================================================================
--- issm/trunk/src/c/objects/Node.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Node.cpp	(revision 4055)
@@ -144,5 +144,5 @@
 				analysis_type==PrognosticAnalysisEnum || 
 				analysis_type==MeltingAnalysisEnum || 
-				analysis_type==SlopeComputeAnalysisEnum || 
+				analysis_type==SlopeAnalysisEnum || 
 				analysis_type==BalancedvelocitiesAnalysisEnum || 
 				analysis_type==BalancedthicknessAnalysisEnum
@@ -668,6 +668,6 @@
 }
 /*}}}*/
-/*FUNCTION Node::FieldExtrude {{{2*/
-void  Node::FieldExtrude(Vec field,double* field_serial,char* field_name){
+/*FUNCTION Node::VecExtrude {{{2*/
+void  Node::VecExtrude(Vec vector,double* vector_serial){
 		
 	/* node data: */
@@ -684,103 +684,27 @@
 	if (onbed){
 
-		if (strcmp(field_name,"velocity")==0){
-
-			/* node data: */
-			int          vertexdof;
-			int          doflist[2];
-			double       fieldnode[2];
-
-			vertexdof=GetVertexDof();
-
-			/*get dofs for this base node velocity: we know there are two dofs in field_serial */
-			doflist[0]=2*vertexdof;
-			doflist[1]=2*vertexdof+1;
-
-			//initilaize node
-			node=this;
-		
-			/*get field for this base node: */
-			fieldnode[0]=field_serial[doflist[0]];
-			fieldnode[1]=field_serial[doflist[1]];
-
-			//go through all nodes which sit on top of this node, until we reach the surface, 
-			//and plfield  field in field
-			for(;;){
-
-				vertexdof=node->GetVertexDof();
-				doflist[0]=2*vertexdof;
-				doflist[1]=2*vertexdof+1;
-				VecSetValues(field,1,&doflist[0],&fieldnode[0],INSERT_VALUES);
-				VecSetValues(field,1,&doflist[1],&fieldnode[1],INSERT_VALUES);
-
-				if (node->IsOnSurface())break;
-				/*get next node: */
-				node=node->GetUpperNode();
-			}
-		} //if (strcmp(field_name,"velocity")==0)
-		else if (strcmp(field_name,"gradj")==0){
-
-			/* node data: */
-			int          dof1;
-			double       fieldel;
-
-			//initilaize node and get dof1
-			node=this;
+		/* node data: */
+		int          dof1;
+		double       vectorel;
+
+		//initilaize node and get dof1
+		node=this;
+		dof1=node->GetVertexDof();
+
+		/*get vector for this base node: */
+		vectorel=vector_serial[dof1];
+
+		//go throvectorn all nodes which sit on top of this node, until we reach the surface, 
+		//and plvector  vector in vector
+		for(;;){
+
 			dof1=node->GetVertexDof();
-
-			/*get field for this base node: */
-			fieldel=field_serial[dof1];
-
-			//go throfieldn all nodes which sit on top of this node, until we reach the surface, 
-			//and plfield  field in field
-			for(;;){
-
-				dof1=node->GetVertexDof();
-				VecSetValues(field,1,&dof1,&fieldel,INSERT_VALUES);
-
-				if (node->IsOnSurface())break;
-				/*get next node: */
-				node=node->GetUpperNode();
-			}
-		}
-		else if ( 
-				(strcmp(field_name,"vx")==0) ||
-				(strcmp(field_name,"vy")==0) ||
-				(strcmp(field_name,"thickness")==0) ||
-				(strcmp(field_name,"temperature")==0) ||
-				(strcmp(field_name,"surface")==0)  ||
-				(strcmp(field_name,"bed")==0)  || 
-				(strcmp(field_name,"slopex")==0)  ||
-				(strcmp(field_name,"slopey")==0) 
-				){
-
-			/* node data: */
-			int          doflist;
-			int          nodedofs;
-			double       fieldnode;
-				
-			GetDofList(&doflist,&numberofdofspernode);
-
-			//initialize node
-			node=this;
-
-			/*get field for this bed node: */
-			fieldnode=field_serial[doflist];
-
-			//go through all nodes which sit on top of this node, until we reach the surface, 
-			//and plug  fieldnode in field:
-			for(;;){
-
-				node->GetDofList(&nodedofs,&numberofdofspernode);
-				VecSetValues(field,1,&nodedofs,&fieldnode,INSERT_VALUES);
-
-				if (node->IsOnSurface())break;
-				/*get next node: */
-				node=node->GetUpperNode();
-			}
-		}
-		else ISSMERROR("%s%s%s"," field ",field_name," not supported yet!");
-
-	} //if (extrude)
+			VecSetValues(vector,1,&dof1,&vectorel,INSERT_VALUES);
+
+			if (node->IsOnSurface())break;
+			/*get next node: */
+			node=node->GetUpperNode();
+		}
+	} 
 }
 /*}}}*/
Index: issm/trunk/src/c/objects/Node.h
===================================================================
--- issm/trunk/src/c/objects/Node.h	(revision 4054)
+++ issm/trunk/src/c/objects/Node.h	(revision 4055)
@@ -89,5 +89,5 @@
 		int   IsOnShelf();
 		int   IsOnSheet();
-		void  FieldExtrude(Vec field,double* field_serial,char* field_name);
+		void  VecExtrude(Vec vector,double* vector_serial);
 		/*}}}*/
 		/*FUNCTION DofObject routines {{{1*/
Index: issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp
===================================================================
--- issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp	(revision 4054)
+++ issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp	(revision 4055)
@@ -25,5 +25,5 @@
 		numdofs=2;
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 		numdofs=1;
 	}
Index: issm/trunk/src/c/shared/Numerics/IsInputConverged.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/IsInputConverged.cpp	(revision 4055)
+++ issm/trunk/src/c/shared/Numerics/IsInputConverged.cpp	(revision 4055)
@@ -0,0 +1,54 @@
+/*!\file:  IsInputConverged.cpp
+ * \brief: figure out convergence at the input level. 
+ * We are given a list of inputs, new and old, and a criterion, and using the inputs, we 
+ * return the value of the criterion test, which will be used at the solution level 
+ * to determine convergence.
+ */ 
+
+#ifdef HAVE_CONFIG_H
+	#include "config.h"
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../../objects/objects.h"
+
+void IsInputConverged(double* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum){
+
+	int i;
+
+	/*output: */
+	double eps;
+	
+	/*intermediary: */
+	double *newvalues     = NULL;
+	double *oldvalues     = NULL;
+	int     num_values;
+	double  ndu        = 0;
+	double  nu         = 0;
+
+	if(criterion_enum==RelativeEnum){
+
+		/*conpute ndu/du (where u could be velocity, pressure, temperature, etc ...): */
+		for(i=0;i<num_inputs;i++){
+			new_inputs[i]->GetValuesPtr(&newvalues,&num_values);
+			old_inputs[i]->GetValuesPtr(&oldvalues,&num_values);
+			for(j=0;j<num_values;j++){
+				ndu+=pow(newvalues[j]-oldvalues[j],2);
+				nu+=pow(oldvalues[j],2);
+			}
+		}
+
+		/*take square root: */
+		ndu=sqrt(ndu);
+		nu=sqrt(nu);
+
+		/*now, compute eps: */
+		if(nu)eps=ndu/nu;
+		else eps=0;
+	}
+	else ISSMERROR("%s%s%s"," convergence criterion ",EnumAsString(criterion_enum)," not supported yet!");
+
+	/*Assign output pointers:*/
+	*peps=eps;
+}
Index: issm/trunk/src/c/shared/Numerics/numerics.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/numerics.h	(revision 4054)
+++ issm/trunk/src/c/shared/Numerics/numerics.h	(revision 4055)
@@ -8,4 +8,5 @@
 #include "./GaussPoints.h"
 #include "./isnan.h"
+class Input;
 
 struct OptArgs;
@@ -18,4 +19,5 @@
 void   cross(double* result,double* vector1,double* vector2);
 double norm(double* vector);
+void IsInputConverged(double* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum);
 
 #endif //ifndef _NUMERICS_H_
Index: issm/trunk/src/c/solutions/adjoint_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/adjoint_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/adjoint_core.cpp	(revision 4055)
@@ -20,4 +20,5 @@
 	char* solverstring=NULL;
 	bool  isstokes=false;
+	bool conserve_loads=true;
 	
 	/*intermediary: */
@@ -38,12 +39,12 @@
 
 	/*set analysis type to compute velocity: */
-	if(isstokes)femmodel->SetAnalysis(DiagnosticAnalysisEnum,DiagnosticStokesAnalysisEnum);
-	else femmodel->SetAnalysis(DiagnosticAnalysisEnum,DiagnosticHorizAnalysisEnum);
+	if(isstokes)femmodel->SetCurrentAnalysis(DiagnosticStokesAnalysisEnum);
+	else femmodel->SetCurrentAnalysis(DiagnosticHorizAnalysisEnum);
 	
 	_printf_("%s\n","      recover solution for this stiffness and right hand side:");
-	solver_diagnostic_nonlinear(NULL,&K_ff0,&K_fs0,NULL, femmodel,DiagnosticAnalysisEnum,sub_analysis_type);
+	solver_diagnostic_nonlinear(NULL,&K_ff0,&K_fs0, femmodel,conserve_loads); 
 
 	_printf_("%s\n","      buid Du, difference between observed velocity and model velocity:");
-	Dux(du_g, femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	Dux(&du_g, femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
 
 	_printf_("%s\n","      reduce adjoint load from g-set to f-set:");
@@ -66,14 +67,14 @@
 
 	/*Update inputs using adjoint solution, and same type of setup as diagnostic solution: */
-	if(isstokes)femmodel->SetAnalysisAlias(DiagnosticAnalysisEnum,DiagnosticStokesAnalysisEnum,AdjointAnalysisEnum,NoneAnalysisEnum);
-	else femmodel->SetAnalysisAlias(DiagnosticAnalysisEnum,DiagnosticHorizAnalysisEnum,AdjointAnalysisEnum,NoneAnalysisEnum);
+	if(isstokes)femmodel->SetCurrentAnalysisAlias(DiagnosticStokesAnalysisEnum,AdjointAnalysisEnum);
+	else femmodel->SetCurrentAnalysisAlias(DiagnosticHorizAnalysisEnum,AdjointAnalysisEnum);
 	
-	UpdateInputsFromSolutionx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,adjoint_g,AdjointAnalysisEnum, NoneAnalysisEnum);
+	UpdateInputsFromSolutionx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,adjoint_g);
 
 	/*Free ressources:*/
-	char* solverstring=NULL;
-	VecFree(&ug);
+	xfree((void**)&solverstring);
+	VecFree(&u_g);
 	MatFree(&K_ff0);
-	MatFree(&Mat K_fs0);
+	MatFree(&K_fs0);
 	VecFree(&du_g);
 	VecFree(&du_f);
Index: issm/trunk/src/c/solutions/balancedthickness.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 4055)
@@ -22,17 +22,10 @@
 	char* inputfilename=NULL;
 	char* outputfilename=NULL;
+	bool  qmu_analysis=false;
 	char* lockname=NULL;
-	int   numberofnodes;
 	bool  waitonlock=false;
 
-	Model* model=NULL;
-
-	double  dt;
-	double  yts;
-	bool    qmu_analysis;
-
-	/*Results: */
-	Results* results=NULL;
-	Param*   param=NULL;
+	/*FemModel: */
+	FemModel* femmodel=NULL;
 
 	/*time*/
@@ -40,4 +33,7 @@
 	double   start_core, finish_core;
 	double   start_init, finish_init;
+
+	int analyses[1]={BalancedthicknessAnalysisEnum};
+	int solution_type=BalancedthicknessAnalysisEnum;
 
 	MODULEBOOT();
@@ -66,13 +62,14 @@
 	fid=pfopen(inputfilename,"rb");
 
-	/*Initialize model structure: */
-	model=new Model();
+	_printf_("create finite element model:\n");
+	femmodel=new FemModel(fid,solution_type,analyses,1);
 
-	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,BalancedthicknessAnalysisEnum);
-
-	/*recover parameters: */
-	model->FindParam(&waitonlock,WaitOnLockEnum);
-	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename);
+	
+	/*get parameters: */
+	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
+	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
@@ -84,6 +81,10 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		results=balancedthickness_core(model);
+		balancedthickness_core(model);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
+
+		_printf_("write results to disk:\n");
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
+	}
 
 	}
@@ -95,5 +96,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,BalancedthicknessAnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,BalancedthicknessAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -101,7 +102,4 @@
 		#endif
 	}
-
-	_printf_("write results to disk:\n");
-	OutputResults(results,outputfilename);
 
 	if (waitonlock>0){
@@ -111,6 +109,5 @@
 
 	/*Free ressources:*/
-	delete results;
-	delete model;
+	delete femmodel;
 
 	/*Get finish time and close*/
Index: issm/trunk/src/c/solutions/balancedthickness2.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 4055)
@@ -23,18 +23,10 @@
 	char* inputfilename=NULL;
 	char* outputfilename=NULL;
+	bool  qmu_analysis=false;
 	char* lockname=NULL;
 	bool  waitonlock=false;
 
-	Model* model=NULL;
-
-	double  dt;
-	double  yts;
-	bool    qmu_analysis;
-
-	/*Results: */
-	Results* results=NULL;
-	Result*  result=NULL;
-
-	Param*   param=NULL;
+	/*FemModel: */
+	FemModel* femmodel=NULL;
 
 	/*time*/
@@ -42,4 +34,8 @@
 	double   start_core, finish_core;
 	double   start_init, finish_init;
+
+	int analyses[1]={Balancedthickness2AnalysisEnum};
+	int solution_type=Balancedthickness2AnalysisEnum;
+
 
 	MODULEBOOT();
@@ -68,13 +64,9 @@
 	fid=pfopen(inputfilename,"rb");
 
-	/*Initialize model structure: */
-	model=new Model();
+	_printf_("create finite element model:\n");
+	femmodel=new FemModel(fid,solution_type,analyses,1);
 
-	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,Balancedthickness2AnalysisEnum);
-
-	/*recover parameters: */
-	model->FindParam(&waitonlock,WaitOnLockEnum);
-	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename);
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
@@ -86,6 +78,9 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		results=balancedthickness2_core(model);
+		balancedthickness2_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
+
+		_printf_("write results to disk:\n");
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
 
 	}
@@ -97,5 +92,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,Balancedthickness2AnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,Balancedthickness2AnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -103,7 +98,4 @@
 		#endif
 	}
-
-	_printf_("write results to disk:\n");
-	OutputResults(results,outputfilename);
 
 	if (waitonlock>0){
@@ -113,6 +105,5 @@
 
 	/*Free ressources:*/
-	delete results;
-	delete model;
+	delete femmodel;
 
 	/*Get finish time and close*/
Index: issm/trunk/src/c/solutions/balancedthickness2_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness2_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/balancedthickness2_core.cpp	(revision 4055)
@@ -12,71 +12,35 @@
 #include "../solvers/solvers.h"
 
-Results* balancedthickness2_core(Model* model){
-
-	extern int my_rank;
-
-	/*output: */
-	Results* results=NULL;
-	Result* result=NULL;
-
-	/*intermediary: */
-	Vec vx_g=NULL;
-	Vec vy_g=NULL;
-
-	/*solutions: */
-	Vec h_g=NULL;
+void balancedthickness2_core(FemModel* femmodel){
 
 	/*flags: */
 	int verbose=0;
-	int numberofdofspernode;
-	int numberofnodes;
-	int numberofvertices;
-	int dofs[1]={1};
+	int dim;
 
-	/*fem balancedthickness2 model: */
-	FemModel* fem_p=NULL;
-
-	//initialize results:
-	results=new Results();
-
-	fem_p=model->GetFormulation(Balancedthickness2AnalysisEnum);
-
-	//first recover parameters common to all solutions
-	model->FindParam(&verbose,VerboseEnum);
-	model->FindParam(&numberofnodes,NumberOfNodesEnum);
-	model->FindParam(&numberofvertices,NumberOfVerticesEnum);
-	model->FindParam(&numberofdofspernode,NumberOfDofsPerNodeEnum);
+	/*activate formulation: */
+	femmodel->SetCurrentAnalysis(BalancedthicknessAnalysisEnum);
+	
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
+	femmodel->parameters->FindParam(&dim,DimEnum);
 
 	_printf_("depth averaging velocity...\n");
-	//vx_g=inputs->Get("vx",&dofs[0],1);
-	//vy_g=inputs->Get("vy",&dofs[0],1);
-	/* NOT WORKING YET....
-	FieldDepthAveragex(vx_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"vx");
-	FieldDepthAveragex(vy_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"vy");
-	*/
-	//inputs->Add("vx_average",vx_g,1,numberofvertices);
-	//inputs->Add("vy_average",vy_g,1,numberofvertices);
-	ISSMERROR("not supported yet!");
-	
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VxEnum);
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VyEnum);
+	if(dim==3) DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VzEnum);
+
+
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,Balancedthickness2AnalysisEnum,NoneAnalysisEnum);
+	solver_linear(NULL,femmodel);
 
 	_printf_("Averaging over vertices:\n");
-	FieldAverageOntoVerticesx(&h_g,fem_p->elements,fem_p->nodes,fem_p->vertices,fem_p->loads,fem_p->materials,fem_p->parameters);
+	ISSMERROR(" not supported yet!");
+//FieldAverageOntoVerticesx(&h_g,fem_p->elements,fem_p->nodes,fem_p->vertices,fem_p->loads,fem_p->materials,fem_p->parameters);
 
 //	_printf_("extrude computed thickness on all layers:\n");
 //	FieldExtrudex( h_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"thickness",0);
 
-	/*Plug results into output dataset: */
-	InputToResultx(&result,fem_p->elements,fem_p->nodes,fem_p->vertices, fem_p->loads, fem_p->materials,fem_p->parameters,ThicknessEnum,results->Size()+1,0,1); results->AddObject(result);
-	results->AddObject(new StringResult(results->Size()+1,AnalysisTypeEnum,0,1,EnumAsString(Balancedthickness2AnalysisEnum)));
-
-	/*Free ressources:*/
-	VecFree(&vx_g);
-	VecFree(&vy_g);
-	VecFree(&h_g);
-	
-	/*return: */
-	return results;
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
 
 }
